



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>获取Spring容器Bean对象工具类</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">获取Spring容器Bean对象工具类</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 10:35:37 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在开发中，总是能碰到用注解注入不了Spring容器里面bean对象的问题。为了解决这个问题，我们需要一个工具类来直接获取Spring容器中的bean。因此就写了这个工具类，在此记录一下，方便后续查阅。废话不多说，直接上代码。</p>
<h2>一、代码</h2>
<p>package com.zxy.demo.spring;</p>
<p>import org.springframework.beans.BeansException;</p>
<p>import org.springframework.context.ApplicationContext;</p>
<p>import org.springframework.context.ApplicationContextAware;</p>
<p>import org.springframework.stereotype.Component;</p>
<p>/**<br /> * 获取Spring容器中bean工具类</p>
<p>* @author liuysh<br /> * @date   2018年6月6日<br /> * <br /> */</p>
<p>@Component("springContextUtils")</p>
<p>public class SpringContextUtils implements ApplicationContextAware {</p>
<p>private static ApplicationContext applicationContext = null;</p>
<p>public static ApplicationContext getApplicationContext() {<br />		return applicationContext;</p>
<p>}</p>
<p>@SuppressWarnings("unchecked")</p>
<p>public static &lt;T&gt; T getBean(String beanId) {</p>
<p>return (T) applicationContext.getBean(beanId);</p>
<p>}</p>
<p>public static &lt;T&gt; T getBean(Class&lt;T&gt; requiredType) {</p>
<p>return (T) applicationContext.getBean(requiredType);</p>
<p>}</p>
<p>/**</p>
<p>* Spring容器启动后，会把 applicationContext 给自动注入进来，然后我们把 applicationContext 赋值到静态变量中，方便后续拿到容器对象</p>
<p>* @see org.springframework.context.ApplicationContextAware#setApplicationContext(org.springframework.context.ApplicationContext)</p>
<p>*/</p>
<p>public void setApplicationContext(ApplicationContext applicationContext) throws BeansException {</p>
<p>SpringContextUtils.applicationContext = applicationContext;</p>
<p>}<br />}</p>
<div>
<h2>二、用法</h2>
</div>
<div>&nbsp; &nbsp; &nbsp; &nbsp; 直接在代码用调用SpringContextUtils静态方法获取bean就ok，可以通过bean的id获取，也可以通过bean的类型获取</div>
<div>
<pre class="prettyprint linenums">RedisUtil redisUtil = SpringContextUtils.getBean(RedisUtil.class);

</pre>
<h2>三、注意事项</h2>
<div>&nbsp; &nbsp; &nbsp; &nbsp; 仔细看代码可以发现我这个工具类上面加了个<strong>@Component</strong>注解。加这个注解的目的是为了把的SpringContextUtils的实例化交给Spring容器管理。当然，你也可以在xml中配置这个，我为了方便，直接用的注解。<strong>注意点：这个工具类的实例化必须由Spring容器来做</strong></div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pjopk9.html">js获取手机验证码倒计时的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/495mx70q.html">Grandle全局变量定义及引用</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdkdzj9.html">装tomcat和nginx心得</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxv3xd9.html">VR是TAA的终结者吗？</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4rodn8.html">&commat;RestController注解下返回到jsp视图页面&lpar;转&rpar;&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1okzr9.html">PHPExcel读取excel的多个sheet存入数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1gm3j8.html">Tick and Tick</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xzdxv8.html">ADO&period;NET笔记（一）XML导入导出和数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvwoooq.html">try、catch、finally与return</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz0xw08.html">UVA 534 - Frogger（kruskal扩展&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90myre38.html">NPOI 表头、页眉页脚重复设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gegw3l8.html">【性能测试工具】- ApacheBench</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1oewxq.html">安装 LightGBM 包的过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdy34y9.html">Phoenix与Hive学习资料</a>
		</li>
						<li><a href="https://www.batexi.com/a/950lgjm8.html">【网络】 应用&amp;amp&semi;传输层笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj6gmlq.html">&period;NET Core IdentityServer4实战-开篇介绍与规划</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljrvw09.html">link&sol;Extended dependency 无法显示连接</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r27k48.html">如何在循环中使用await？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2nlex9.html">Django-website 程序案例系列-4 ORM数据库操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll4ov0q.html">webstorm安装流程</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlllznkq.html">Java多线程之内存可见性</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwpnmz8.html">vmware启动黑屏&lpar;本来是好的&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1mj2e9.html">使用Retrofit2&plus;RxJava2&plus;ProtoBuf实现网络请求</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r27p39.html">WPF Modern UI 主题更换原理</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4me7e9.html">java实现无序数组结构</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o14nr1q.html">Github被微软收购，这里整理了16个替代品</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jpgl0q.html">ql语句中left join和inner join中的on与where的区别分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wpxxnq.html">idea代码快捷</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjpey79.html">JavaScript之Number、String、Array常用属性与方法手册</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjp31e9.html">css文本超出隐藏显示省略号</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
